/**
 * CSCI 201 - Lab 5
 * 
 * @author [add group member names here]
 */

/**
 * A node to be used in a doubly-linked list of characters,
 * representing a line in a text editor.
 */
class CharacterNode {
  public CharacterNode prev;
  public CharacterNode next;
  private char character;

  /**
   * Creates a doubly-linked list node, saving the character,
   * and making the prev and next pointers null.
   */
  public CharacterNode(char c) {
    character = c;
    prev = null;
    next = null;
  }

  /**
   * Retrieves the character stored at this node.
   */
  char get() {
    return character;
  }
}

/**
 * Represents a line of text in a text editor.
 */
public class Line {

  CharacterNode head;
  CharacterNode cursor;

  /**
   * Creates an empty Line.
   */
  public Line() {
    head = null;
    cursor = null;
  }

  /**
   * Creates a Line from an input sequence of characters.
   * The cursor should be placed at the beginning of the line
   * after creating the linked list.
   * 
   * @param line - sequence of characters to store in the linked list.
   */
  public Line(String line) {
    // TODO
  }

  /**
   * Inserts a character right after the current cursor location (the character preceeding the '|').
   * For example, calling insert('a') when the current Line is 'ban|na' will produce 'bana|na'.
   * 
   * @param c - character to insert.
   */
  public void insert(char c) {
    // TODO
  }

  /**
   * Deletes the character at the cursor location.
   * For example, calling delete() when the current Line is 'spider|rman' will produce 'spide|rman'.
   */
  public void delete() {
    // TODO
  }

  /**
   * Moves the cursor to the previous character (if possible).
   */
  public void moveCursorLeft() {
    // TODO
  }

  /**
   * Moves the cursor to the next character (if possible).
   */
  public void moveCursorRight() {
    // TODO
  }

  /**
   * Retrieves the entire Line as a String.
   *  
   * @param withCursor - option to add a vertical bar (|) where the cursor is.
   * @return String representation of this Line.
   */
  public String get(boolean withCursor) {
    if (head == null) {
      return withCursor ? "|" : "";
    }
    String line = (withCursor && cursor == null) ? "|" : "";
    CharacterNode node = head;
    while (node != null) {
      line += node.get();
      if (node == cursor && withCursor) {
        line += "|";
      }
      node = node.next;
    }
    return line;
  }

  /**
   * Test some line methods here.
   */
  public static void main(String[] args) {
    Line line = new Line();
    line.insert('b');
    line.insert('a');
    line.insert('n');
    line.insert('n');
    line.insert('n');
    line.insert('a');
    line.moveCursorLeft();
    line.moveCursorLeft();
    line.insert('a');
    line.moveCursorLeft();
    line.delete();
    System.out.println(line.get(true));
  }
}